package DB;

// A cell is a key-value pair that is liked to two other cells: prev and next.

public class Cell implements CellI {

    private String name;
    private int    value;
    private CellI  prev;
    private CellI  next;
    
    public Cell (String aName, int aValue)
    {
        name  = aName;
        value = aValue; 
        prev  = null;
        next  = null;
    }
    
    //remote constructor
    static public CellI newCell(String aName, Integer aValue){
	Cell aCell = new Cell(aName, aValue.intValue());
	return aCell;
    }

    public void
    linkBefore (CellI that)
    {
    	prev = that.getPrev ();
    	next = that;
	that.setPrev (this);
    }
    
    public boolean
    unlink()
    {
	boolean more;

	more = false;
    	if (prev!=null) {
	    prev.setNext (next);
 	    more = true;
	}
    	if (next!=null) {
	    next.setPrev (prev);
	    more = true;
	}

	return more;
    }

    public void
    setNext (CellI aCell)
    {
	next = aCell;
    }

    public void
    setPrev (CellI aCell)
    {
	prev = aCell;
    }
    
    public CellI
    getNext ()
    {
    	return next;
    }

    public CellI
    getPrev ()
    {
	return prev;
    }
    
    public String
    getName ()
    {
    	return name;
    }
    
    public int
    getValue ()
    {
    	return value;
    }
}
