package DB;

public class CellCP extends RPC.ClientProxy implements CellI
{
    private Object retObj;
    static public String outputHdr = "##   DB.Cell: ";
    static public IPC.ComHandle remoteCH;

    int thisClassID = RPC.ClassID.Cell;

    /*CellCP(String aName, int aValue)
    {
	try{
	    retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
				  "newCell", CellRPC.newCell_version, 
				  new String[]{"java.lang.String", "java.lang.Integer"}, 
				  new Object[] {aName, new Integer(aValue)}) );
	    cap = (CellCP)retObj.getCap();
	    Client.capRegistry.put(cap, this);
	} catch(Exception e) {
	    Debug("Exception in Cell constructor: ", e);
	    return null;
	}   
	}*/

    public CellCP(RPC.Capability cap)
    {
	super(cap);
    }

    public void linkBefore (CellI that){
	
	try{
	retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "linkBefore", CellRPC.linkBefore_version, 
			 new String[]{"DB.Cell"}, new Object[] {that});
	}catch(Exception e){
	    Debug("Exception in linkBefore: ", e);
	}
    }
    
    public boolean unlink(){
	try{
	retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "unlink", CellRPC.unlink_version, 
			 new String[]{}, new Object[] {});
	
	return ((Boolean)retObj).booleanValue();
	}catch(Exception e){
	    Debug("Exception in unlink: " , e);
	    return false;
	}
    }

    public void setNext(CellI aCell){
	try{
	    retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "setNext", CellRPC.setNext_version, 
			 new String[]{"DB.Cell"}, new Object[] {aCell});
	}catch(Exception e){
	    Debug("Exception in setNext", e);
	}
    }
	
	
    public void setPrev(CellI aCell){
	try{
	    retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "setPrev", CellRPC.setPrev_version, 
			 new String[]{"DB.Cell"}, new Object[] {aCell});
	}catch(Exception e){
	    Debug("Exception in setPrev", e);
	}
    }

    public CellI getNext(){
	try{
	    retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "getNext", CellRPC.getNext_version, 
			 new String[]{}, new Object[] {});

	    return (CellI)retObj;

	}catch(Exception e){
	    Debug("Exception in getNext", e);
	    return null;
	}
    }

    public CellI getPrev(){
	try{
	    retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "getPrev", CellRPC.getPrev_version, 
			 new String[]{}, new Object[] {});

	    return (CellI)retObj;

	}catch(Exception e){
	    Debug("Exception in getPrev", e);
	    return null;
	} 
    }

    public String getName(){
        try{
	    retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "getName", CellRPC.getName_version, 
			 new String[]{}, new Object[] {});

	    return (String)retObj;

	}catch(Exception e){
	    Debug("Exception in getName", e);
	    return null;
	} 
    }
    
    public int getValue(){
	try{
	    retObj = remoteInvoke(this, thisClassID, CellRPC.CLASS_VERSION,
			 "getValue", CellRPC.getValue_version, 
			 new String[]{}, new Object[] {});

	    return ((Integer)retObj).intValue();

	}catch(Exception e){
	    Debug("Exception in getValue", e);
	    return -1; // best we can do without throwing exceptions
	} 
    }

    private void Debug(String msg, Exception De){
	System.out.println(outputHdr + msg + De.getMessage());
    }

}
