package DB;

import java.util.Hashtable;


// A database is a collection of tables


public class DatabaseCP extends RPC.ClientProxy implements DatabaseI
{
    private Object retObj;
    int thisClassID = RPC.ClassID.Database;
    static final String outputHdr = "##  ClientProxy: ";

    static public IPC.ComHandle remoteCH;

    /*public 
    DatabaseCP(String aName)
    {
	try{
	    retObj = remoteInvoke(this, thisClassID, DatabaseRPC.CLASS_VERSION, 
				  "newDatabase", DatabaseRPC.newDatabase_version, 
				  new String[]{"java.lang.String"}, new Object[]{aName});
	    cap = (DatabaseCP)retObj.getCap();
	    Client.capRegistry.put(cap, this);
	}catch(Exception e) {
	    Debug("Exception in Table constructor: ", e);
	    return null;
	}
	}*/

    public DatabaseCP(RPC.Capability cap)
    {
	super(cap);
    }

    public void
    addTable (TableI table)
    {
        try{
	    retObj = remoteInvoke(this, thisClassID, DatabaseRPC.CLASS_VERSION, 
				  "addTable", DatabaseRPC.addTable_version, 
				  new String[]{"DB.Table"}, new Object[]{table});
	}catch(Exception e) {
	    Debug("Exception in addTable: ", e);
	}
    }

    public void
    removeTable (TableI table)
    {
        try{
	    retObj = remoteInvoke(this, thisClassID, DatabaseRPC.CLASS_VERSION, 
				  "removeTable", DatabaseRPC.removeTable_version, 
				  new String[]{"DB.Table"}, new Object[]{table});
	}catch(Exception e) {
	    Debug("Exception in removeTable: ", e);
	}
    }

    public TableI
    addNewTable (String name)
    {
        try{
	    retObj = remoteInvoke(this, thisClassID, DatabaseRPC.CLASS_VERSION, 
				  "addNewTable", DatabaseRPC.addNewTable_version, 
				  new String[]{"java.lang.String"}, new Object[]{name});
	    return (TableI)retObj;
	}catch(Exception e) {
	    Debug("Exception in addNewTable: ", e);
	    return null;
	}
    }

    public TableI
    lookupTable (String name)
    {
        try{
	    retObj = remoteInvoke(this, thisClassID, DatabaseRPC.CLASS_VERSION, 
				  "lookupTable", DatabaseRPC.lookupTable_version, 
				  new String[]{"java.lang.String"}, new Object[]{name});
	    return (TableI)retObj;
	}catch(Exception e) {
	    Debug("Exception in lookupTable: ", e);
	    return null;
	}
    }

    public String
    getName ()
    {
        try{
	    retObj = remoteInvoke(this, thisClassID, DatabaseRPC.CLASS_VERSION, 
				  "getName", DatabaseRPC.getName_version, 
				  new String[]{}, new Object[]{});
	    return (String)retObj;
	}catch(Exception e) {
	    Debug("Exception in getName: ", e);
	    return null;
	}
    }

    private void Debug(String msg, Exception De){
	System.out.println(outputHdr + msg + De.getMessage());
    }
}
