package DB;

// A node is an element of an Index tree.  It names a cell, has a key, and left
// and right neighbors.  Inserting a cell adds it in order.

public class Node implements NodeI{

    String  key;
    CellI   cell;
    Node    left;
    Node    right;

    public Node (String key, CellI cell)
    {
	this.key   = key;
	this.cell  = cell;
	this.left  = null;
	this.right = null;
    }

    public void
    insert (String key, CellI cell)
    {
	if (key.compareTo(this.key) <= 0) {
	    if (left==null)
	        left = new Node (key, cell);
	    else
		left.insert (key, cell);
	} else {
	    if (right==null)
	        right = new Node (key, cell);
	    else
		right.insert (key, cell);
	}
    }

    public void
    printInOrder ()
    {
    	if (left!=null)
    	    left.printInOrder ();
    	System.out.println (cell.getName() + " " + cell.getValue());
    	if (right!=null)
    	    right.printInOrder ();
    }

    public String printInOrderString()
    {
	String leftPrint = "";
	String rightPrint = "";
	String currPrint = "";

	if(left!=null)
	    leftPrint = left.printInOrderString();
	if(right!=null)
	    rightPrint = right.printInOrderString();
	currPrint = cell.getName() + " " + cell.getValue() + "\n";
	return leftPrint + currPrint + rightPrint;
    }
}
