package DB;

import java.util.Hashtable;

// A table is a double-linked ordered collection of cells with one special 
// cell called the "first" cell.


public class Table implements TableI {
    private String    name;
    private Hashtable cellSet;
    private CellI     firstCell;
    static final String outputHdr = "##  DB.Table: ";
    public 
    Table (String aName)
    {
	name      = aName;
    	cellSet   = new Hashtable ();
    	firstCell = null;
    }

    public void
    addCell (CellI cell)
    {
        cellSet.put (cell.getName(), cell);
        if (firstCell!=null)
            cell.linkBefore (firstCell);
        firstCell = cell;
    }

    public void
    removeCell (CellI cell)
    {
        cellSet.remove (cell.getName());
        if (cell.unlink() == false)
            firstCell = null;
    }
    
    public CellI
    addNewCell (String name, int value)
    {
	CellI cell;

	cell = new Cell (name, value);
	addCell (cell);

	return cell;
    }

    public CellI addNewCell(String name, Integer value)
    {
	System.out.println(outputHdr + "adding new cell2");
	CellI c = addNewCell(name, value.intValue());
	return c;
    }
    
    public CellI
    lookupCell (String name)
    {
    	return (CellI) cellSet.get (name);
    }
    
    public CellI
    getFirstCell ()
    {
    	return firstCell;
    }

    public String
    getName ()
    {
        return name;
    }
}
