package DB;

public class TableCP extends RPC.ClientProxy implements TableI
{
    private Object retObj;
    static public String outputHdr = "##   DB.Table: ";
    static public IPC.ComHandle remoteCH;
    int thisClassID = RPC.ClassID.Table;
    
    /*public TableCP(String aName)
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "newTable", TableRPC.newTable_version, 
				  new String[]{"java.lang.String"}, new Object[] {aName});
	    cap = (TableCP)retObj.getCap();
	    Client.capRegistry.put(cap, this);
	}catch(Exception e){
	    Debug("Exception in Table constructor: ", e);
	}
	}*/

    public TableCP(RPC.Capability cap)
    {
	super(cap);
    }

    public void addCell(CellI cell)
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "addCell", TableRPC.addCell_version, 
				  new String[]{"DB.Cell"}, new Object[] {cell});
	}catch(Exception e){
	    Debug("Exception in addCell: ", e);
	}
    }

    public void removeCell(CellI cell)
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "removeCell", TableRPC.removeCell_version, 
				  new String[]{"DB.Cell"}, new Object[] {cell});
	}catch(Exception e){
	    Debug("Exception in removeCell: ", e);
	}
    }

    public CellI addNewCell(String name, int value)
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "addNewCell", TableRPC.addNewCell_version, 
				  new String[]{"java.lang.String", "java.lang.Integer"}, 
				  new Object[] {name, new Integer(value)});
	    return (CellI)retObj;
	}catch(Exception e){
	    Debug("Exception in addNewCell: ", e);
	    return null;
	}
    }

    public CellI addNewCell(String name, Integer value)
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "addNewCell", TableRPC.addNewCell_version, 
				  new String[]{"java.lang.String", "java.lang.Integer"}, 
				  new Object[] {name, value});
	    return (CellI)retObj;
	}catch(Exception e){
	    Debug("Exception in addNewCell: ", e);
	    return null;
	}
    }

    public CellI lookupCell(String name)
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "lookupCell", TableRPC.lookupCell_version, 
				  new String[]{"java.lang.String"}, new Object[] {name});
	    return (CellI)retObj;
	}catch(Exception e){
	    Debug("Exception in lookupCell: ", e);
	    return null;
	}
    }

    public CellI getFirstCell()
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "getFirstCell", TableRPC.getFirstCell_version, 
				  new String[]{}, new Object[] {});
	    return (CellI)retObj;
	}catch(Exception e){
	    Debug("Exception in getFirstCell: ", e);
	    return null;
	}
    }

    public String getName()
    {	
	try{
	    retObj = remoteInvoke(this, thisClassID, TableRPC.CLASS_VERSION,
				  "getName", TableRPC.getName_version, 
				  new String[]{}, new Object[] {});
	    return (String)retObj;
	}catch(Exception e){
	    Debug("Exception in getName: ", e);
	    return null;
	}
    }

    private void Debug(String msg, Exception De){
	System.out.println(outputHdr + msg + De.getMessage());
    }

}
