package IPC;

import java.util.Hashtable;
import java.io.IOException;
import java.net.DatagramSocket;


class Call {

    int     seqNum;
    Message respMsg;
    boolean received;
    boolean iaaReceived;
    int     ayaRemaining;

    Call (int seqNum)
    {
	this.seqNum       = seqNum;
	this.respMsg      = null;
	this.received     = false;
	this.iaaReceived  = false;
	this.ayaRemaining = 0;
    }
}


public class CallRec {

    Hashtable pendingCalls;

    CallRec ()
    {
	pendingCalls = new Hashtable();
    }

    Message
    sendReceive (DatagramSocket socket, ComHandle dest, int seqNum, Message reqMsg)
	throws IOException
    {
	int       timeout;
	Integer   seqNumI;
	Call      call;

	seqNumI = new Integer (seqNum);
	call    = new Call (seqNum);

	//
	// Send request, handle AYA/IAA, and wait for response
	//

	synchronized (call) {

	    try {

	        timeout = Params.reqTimeout;
	        pendingCalls.put (seqNumI, call);
	        reqMsg.send      (socket);

	        for (;;) {

	            call.wait (timeout);

	            if (call.received) 
			return call.respMsg;

		    if (call.iaaReceived) {
			timeout           = Params.ayaTimeout;
			call.ayaRemaining = Params.reqRetryLimit;
			call.iaaReceived  = false;
			continue;
		    }

		    if (call.ayaRemaining != 0) {
			timeout               = Params.reqTimeout;
			call.ayaRemaining -= 1;
		        reqMsg = new Message ();
		        reqMsg.setComHandle  (dest);
		        reqMsg.setType       (MessageType.ARE_YOU_ALIVE);
			reqMsg.setSeqNum     (seqNum);
			reqMsg.send          (socket);
		        continue;
		    }

		    break;
	        }

	    } catch (InterruptedException ie) {}

	    //
	    // Timeout (or other error)
	    //
	    pendingCalls.remove   (seqNumI);
	    throw new IOException ();
	}
    }

    boolean
    complete (int seqNum, Message respMsg)
    {
	int     respType;
	Integer seqNumI;
	Call    call;

	seqNumI = new Integer(seqNum);
	call = (Call) pendingCalls.get (seqNumI);

	if (call == null)
	    return false;

	synchronized (call) {

	    try {
	        respType = respMsg.getType ();
	    } catch (MarshalException me) {
		respType = -1;
	    }
	        
	    if (respType == MessageType.I_AM_ALIVE) {
	        call.iaaReceived = true;
	    } else {
	        call.received = true;
	        pendingCalls.remove (seqNumI);
	        call.respMsg = respMsg;
	    }

	    call.notify ();
	}

	return true;
    }
}
