package IPC.Test;

import java.io.FileOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class TestServer {

    public static void
    registerToFile (String fileName, Server server)
    {
        FileOutputStream fos;
        DataOutputStream dos;

        try {
            fos = new FileOutputStream (fileName);
            dos = new DataOutputStream (fos);
            server.getComHandle().marshal (dos);
            fos.close ();
        } catch (java.io.IOException io) {
            throw new IPC.ServerUnreachableException ();
        }	
   }

    public static void
    main(String argv[])
    {
	String usageString = "usage: TestServer <server-name> <epoch-number>";
        String serverName;
        Server server;

	try {
            serverName = argv[0];
	    server     = new Server (Integer.parseInt(argv[1]));
	} catch (ArrayIndexOutOfBoundsException abe) {
	    System.out.println (usageString);
	    return;
	} catch (NumberFormatException e) {
	    System.out.println (usageString);
	    return;
        } catch (IOException ie) {
	    System.out.println ("IO Exception");
	    return;
	}
        
        registerToFile (serverName, server);
	server.start ();
    }
}