package NameServer;

import java.util.Hashtable;
import java.lang.*;
import java.io.*;

public class NameContext implements NameContextI {

    static final String outputHdr = "##  NameServer.NameContext: ";

    Hashtable table;

    static {
	//System.out.println(outputHdr + "Loading class into class Registry");
	String verNum, ClassNum, HashKeyVal;
	ClassNum = String.valueOf(RPC.ClassID.NameContext);
	verNum = String.valueOf(NameContextRPC.CLASS_VERSION);
	HashKeyVal = ClassNum + "." + verNum;
	RPC.Server.classRegistry.put(HashKeyVal, "NameServer.NameContext");
    }

    // constructor
    public 
    NameContext ()
    {
	table = new Hashtable ();
    }

     public static NameContextI getRootContext(){
	     return RPC.ClientProxy.rootNameContext;
    }
    // create a context object at the name server
    public NameContextI
    addContext (String name)
    {
	NameContextI newNC;
	//System.out.println(outputHdr + "Creating new NC object on server...");
	newNC = new NameContext ();
	table.put (name, newNC);
	
	return newNC;
    }
    
    // add an object to this context
    public void 
    add (String name, Object object)
    {
	table.put (name, object);
    }

    // remove named object from this context
    public void
    remove (String name)
    {
	table.remove (name);
    }

    // return named object from this context if there is one (NULL otherwise)
    public Object
    lookup (String name)
    {
	return table.get (name);
    }
}
