package NameServer;

import RPC.*;
import NameServer.*;
import IPC.ComHandle;
import java.lang.reflect.*;
import java.io.IOException;
public class NameContextCP extends RPC.ClientProxy implements NameContextI
{
    int thisClassID = RPC.ClassID.NameContext;
    static public String outputHdr = "##   NameServer.NameContextCP: ";
    static public IPC.ComHandle remoteCH;

    static IPC.ComHandle getClassComHandle(){
	 return remoteCH;
    }

    public static void bind(String destServerName){
	try{
	
	remoteCH = bindClass("NameServer.NameContext",  destServerName);
	//System.out.println(outputHdr + "Binding of NameContextCP was Successful.");
	//ClassCH is in the parent class
	}catch (IOException ioe){
	    System.out.println(outputHdr + "IOException in NameContextCP.bind: " + ioe.getMessage());
	}catch(Exception e){
	    System.out.println(outputHdr + "Unexpected error in bind: " + e.getMessage());
	}
    }
    
    public static NameContextI getRootContext(){

	     return rootNameContext;
    }

    public NameContextCP(RPC.Capability aCap){
	super(aCap);
    }
    
    public NameContextI addContext (String name)
    {
	    Object retObj;
	    NameContextI retNC;

	try{
	    retObj = remoteInvoke(this, thisClassID, NameContextRPC.CLASS_VERSION,
			 "addContext", NameContextRPC.addContext_version, 
			 new String[]{"java.lang.String"}, new Object[] {name});
	    retNC = (NameContextI)retObj;
	    return retNC;
	}catch (Exception e){
	    System.out.println("Exception in NameContextCP: " + e.getMessage());
	    return null;
	}
    }
    
    public void add (String name, Object object)
    {
	ServerProxy aSP;
	Capability NCCap;
        Object retObj;


	try{
	    retObj = remoteInvoke(this, thisClassID,  NameContextRPC.CLASS_VERSION,
			 "add", NameContextRPC.add_version, 
			 new String[]{"java.lang.String","java.lang.Object" }, new Object[] {name,object});
	
	}catch(Exception e){
	    System.out.println("Error: " + e.getMessage() );
	}
	
    }
    
    public void remove (String name)
    {
	Object retObj;

	try{
	    retObj = remoteInvoke(this, thisClassID,  NameContextRPC.CLASS_VERSION,
			 "remove", NameContextRPC.remove_version, 
			 new String[]{"java.lang.String"}, new Object[] {name});

	}catch(Exception e){
	    System.out.println("Error: " + e.getMessage() );
	}
    }
    
    public Object lookup (String name)
    {
	RequestMessage req = new RequestMessage();
	ResponseMessage resp;
	Object retObj;

	try{
	    retObj = remoteInvoke(this, thisClassID, NameContextRPC.CLASS_VERSION,
			 "lookup", NameContextRPC.lookup_version, 
			 new String[]{"java.lang.String"}, new Object[] {name});
	    //System.out.println(outputHdr + "got return object from NameContext Lookup: " + retObj.getClass().getName());
	return retObj;
	}catch(Exception e){
	    System.out.println("Error: " + e.getMessage() );
	    return null;
	}
    }

}




