package NameServer;

import java.util.Hashtable;


//
// [NameServer]
//

public class NameServer {
    
    static NameContextI rootContext;
    static public String outputHdr = "##   NameServer.NameServer: ";
    // called when class is loaded
    static {
	
	String verNum, ClassNum, HashKeyVal;
	ClassNum = String.valueOf(RPC.ClassID.NameServer);
	verNum = String.valueOf(NameServerRPC.CLASS_VERSION);
	HashKeyVal = ClassNum + "." + verNum;
	RPC.Server.classRegistry.put(HashKeyVal, "NameServer.NameServer");

	ClassNum = String.valueOf(RPC.ClassID.NameContext);
	verNum = String.valueOf(NameContextRPC.CLASS_VERSION);
	HashKeyVal = ClassNum + "." + verNum;
	RPC.Server.classRegistry.put(HashKeyVal, "NameServer.NameContext");

	rootContext = new NameContext();
    }

    // return the root context object
    public static NameContextI
    getRootContext ()
    {
	return rootContext;
    }
    
    // OO-RPC server mainline.  This is what it looks like for my version
    // of RPC.  I left it here so that you can get an idea of what you
    // might want to do.  Of course, you can change this anyway you like.
    public static void main (String[] argv)
    { 
	String usageString = "usage: NameServer <NAME> <EPOCH>";
	String name;
	int    epoch;

	try {
	    name  = argv[0];	    
	    epoch = Integer.parseInt (argv[1]);
	} catch (ArrayIndexOutOfBoundsException abe) {
	    System.out.println (usageString);
	    return;
	} catch (NumberFormatException e) {
	    System.out.println (usageString);
	    return;
	}

	try {
	RPC.Server.start           (epoch);   // start the IPC.server thread
	NameServerSP.registerClassToFile ("NameServer.NameServer",  name ); 
	RPC.Client aClient = new RPC.Client();
	// register ComHandle to file
	//String newNCName = RPC.Server.server.getComHandle().getAddress().getHostName();
	
	//add a name context for this server (the DNS name)
	RPC.Server.LocalNameContext = rootContext.addContext(name);


	//register all publicly available classes under this Namecontext
	//RPC.Server.ServerNameContext.add("NameServer.NameContext", RPC.Server.server.getComHandle());
	//NameContextSP rootSP = new NameContextSP(rootContext);
	RPC.Server.LocalNameContext.add("NameServer.NameContext", RPC.Server.server.getComHandle());
	System.out.println(outputHdr + "Registered class NameContext.NameContext with comHandle: " +
			   (RPC.Server.server.getComHandle()).toString());

	Object lookupObj = rootContext.lookup(name);
	if(lookupObj == null) {
	    System.out.println(outputHdr + "could not find local name context under root name context.");
	} else {
	    System.out.println(outputHdr + "found local name context.");
	}

	System.out.println("\nFinished Registering Class, Joining server now...\n");
	RPC.Server.join            ();        // block mainline thread
	}catch(Exception e) {
	    System.out.println(outputHdr + "caught exception.");
	}
    }
}
