package NameServer;

// This is the server proxy class for the NameServer class.  Any class that
// exports a "class method" via RPC will need one of these, but classes that
// export exclusively "object methods" do not need one.
//
// What you actually put here will depend on how you implement your 
// RPC.ServerProxy class.  So, do that first.  What you see here is what
// is required for my RPC.ServerProxy, you might have something completely
// different.
//
// Note also that binding and registration of the NameServer class will
// be handled differently from all other classes, because all of the other
// classes will use the NameServer for these purposes while the NameServer
// itself will use a file (that's why 'registerClassToFile' does)
//

public class NameServerSP extends RPC.ServerProxy 
{
    //private static final String className = "NameServer.NameServer";

    static final String outputHdr = "##  NameServer.NameServerSP: ";
    
    public NameServerSP(Object obj){
	super(obj);
    }

    public static void
    registerClass (String className, String ncName,  String FileName)
    {
	//System.out.println(outputHdr + "registering class.");
	registerClassToFile(className, FileName);
    }

    public static void
    handleRequest(RPC.RequestMessage req, RPC.ResponseMessage resp,String ClassName)
    {
	RPC.ServerProxy.handleRequest(req, resp, ClassName);
    }

   
}
