package RPC;

import java.io.IOException;
import IPC.MarshalException;

// This class is the full implementation of the RequestMessage class
// that I used in my solution.  Change it if you like, but you shouldn't
// have to.


public class RequestMessage extends Message {

    final static int hdrOffRequestType = 0;
    final static int hdrOffClassId     = 4  + hdrOffRequestType;
    final static int hdrOffClassVer    = 4  + hdrOffClassId;
    final static int hdrOffMethodId    = 4  + hdrOffClassVer;
    final static int hdrOffMethodVer   = 4  + hdrOffMethodId;
    final static int hdrOffTargetCap   = 4  + hdrOffMethodVer;
    final static int hdrSize           = 36 + hdrOffTargetCap;

    protected int
    getHeaderSize ()
    {
	return super.getHeaderSize() + hdrSize;
    }
    
    public int
    getRequestType ()
   	throws IPC.MarshalException
    {
	return getIntAt (super.getHeaderSize() + hdrOffRequestType);
    }
    
    public int
    getClassId ()
	throws IPC.MarshalException
    {
    	return getIntAt (super.getHeaderSize() + hdrOffClassId);
    }
    
    public int
    getClassVer ()
	throws IPC.MarshalException
    {
    	return getIntAt (super.getHeaderSize() + hdrOffClassVer);
    }
    
    public int
    getMethodId ()
	throws IPC.MarshalException
    {
    	return getIntAt (super.getHeaderSize() + hdrOffMethodId);
    }
    
    public int
    getMethodVer ()
	throws IPC.MarshalException
    {
    	return getIntAt (super.getHeaderSize() + hdrOffMethodVer);
    }
    
    public Capability
    getTargetCap ()
        throws IPC.MarshalException
    {
	return getCapAt (super.getHeaderSize() + hdrOffTargetCap); 
    }
   
    public void
    setRequestType (int num)
    {
	setIntAt (super.getHeaderSize() + hdrOffRequestType, num);
    }
    
    public void
    setClassId (int num)
    {
    	setIntAt (super.getHeaderSize() + hdrOffClassId, num);
    }
    
    public void
    setClassVer (int num)
    {
    	setIntAt (super.getHeaderSize() + hdrOffClassVer, num);
    }
    
    public void
    setMethodId (int num)
    {
    	setIntAt (super.getHeaderSize() + hdrOffMethodId, num);
    }
    
    public void
    setMethodVer (int num)
    {
    	setIntAt (super.getHeaderSize() + hdrOffMethodVer, num);
    }
    
    public void
    setTargetCap (Capability cap)
    {
	setCapAt (super.getHeaderSize() + hdrOffTargetCap, cap);
    }    
}
