package RPC;

import IPC.MarshalException;
import IPC.MessageFullException;
import IPC.AssertException;
import java.lang.reflect.*;


public class ServerRequest extends IPC.ServerRequest {

    static final String outputHdr = "##  RPC.ServerRequest: ";

    protected
    ServerRequest (Server server, IPC.Message reqMsg)
    {
	super (server, reqMsg);
    }

    // handle dispatching of incoming RPC request message
    protected IPC.Message
    handleRequest () 
    {
	// implementation is up to you
	// calls handleRequest on the correct class.
	
	int classID, classVer;
	String className;
	Class reqClass;
	ResponseMessage resp = new ResponseMessage();
	Method reqHandler;
	
	System.out.println("\n\n\n\n" + outputHdr + "received message.");

	try {
	    //System.out.println(outputHdr + "RequestType: " + ((RequestMessage)reqMsg).getRequestType());
	    classID = ((RequestMessage)reqMsg).getClassId();
	    //System.out.println(outputHdr + "ClassID: " + classID);
	    classVer = ((RequestMessage)reqMsg).getClassVer();
	    //System.out.println(outputHdr + "Class Version: " + classVer);
	    className = (String)(Server.classRegistry.get(classID + "." 
							  + classVer));
	    //System.out.println(outputHdr + "Class Name: " + className);
	    //System.out.println(outputHdr + "Method ID: " + ((RequestMessage)reqMsg).getMethodId());
	    
	    //System.out.println(outputHdr + "Method Version: " + ((RequestMessage)reqMsg).getMethodVer());
	    reqClass = Class.forName(className + "SP");
	    //System.out.println(outputHdr + "Found class " + reqClass.getName());
	    reqHandler = reqClass.getMethod("handleRequest", 
					    new Class[] {RequestMessage.class, 
							 ResponseMessage.class, 
							 String.class});
	    //System.out.println(outputHdr + "calling handleRequest on Class "
	    //		       + reqClass.getName() + "...");
	    reqHandler.invoke(reqClass, new Object[] {(RequestMessage)reqMsg, 
						      resp, className});
	} catch(Exception e) {
	    resp.setResponseType(ResponseType.BAD_CLASS);
	    System.out.println(outputHdr + "bad class");
	}
	System.out.println(outputHdr + "handleRequest complete.  Returning response message.");
	return resp;
    }
}
