package TestRPC;

import NameServer.*;
import java.io.*;
import RPC.*;

public class TestClient extends RPC.Client
{
    static final String outputHdr = new String("\n\n\n\n##  TestRPC.TestClient: ");
  
    public TestClient ()
    throws IOException
    {
	
	    super();
	    client = this;
    }

    public static void main(String argv[])
    {


	String usageString = "usage: TestClient <LocalServerName> <NameServer> <epoch>";
	String localNCName = argv[0];
	String nsName = argv[1];
	//String arg0 = argv[2];
	int    epoch = Integer.parseInt (argv[2]);
	try {

	    RPC.Server.start           (epoch);
	    TestClient aClient = new TestClient();

	    System.out.println(outputHdr + "Binding NameServerCP class...\n");
	    NameServerCP.bind("NameServer.NameServer", nsName);

	    System.out.println("Binding NameContextCP class...\n");
	    NameContextCP.bind(nsName); 
	    
	    System.out.println(outputHdr + "getting static root context...\n");
	    NameContextI nc1 = NameContextCP.rootNameContext;

	    System.out.println(outputHdr + "Creating a new NameContext for the local machine.");
	    //String localNCName = Server.server.getComHandle().getAddress().getHostName();
	    Server.LocalNameContext = NameContextCP.rootNameContext.addContext(localNCName);

	    System.out.println(outputHdr + "adding context Kevin...\n");
	    NameContextI Kevin = nc1.addContext("Kevin");

	    System.out.println(outputHdr + "adding context Mary...\n");
	    NameContextI Mary = nc1.addContext("Mary");
	    
	    // register the name context class with the name server
	    String verNum, ClassNum, HashKeyVal;
	    ClassNum = String.valueOf(RPC.ClassID.NameServer);
	    verNum = String.valueOf(NameServerRPC.CLASS_VERSION);
	    HashKeyVal = ClassNum + "." + verNum;
	    RPC.Server.classRegistry.put(HashKeyVal, "NameServer.NameServer");

	    //serverObject (on the client)
	    System.out.println(outputHdr + "creating new local context Philip...\n");
	    NameContext Philip = new NameContext();

	    System.out.println(outputHdr + "adding local context Philip to Kevin...\n");
            Kevin.add("Philip", Philip);

	    System.out.println(outputHdr + "creating new local context Jen...\n");
	    NameContext Jen = new NameContext();
	    Mary.add("Jen", Jen);

	    System.out.println(outputHdr + "adding context Bary...\n");
	    Jen.addContext("Bary");

	    boolean sameObject;
	    String PhilipClassName = (Kevin.lookup("Philip")).getClass().getName();
	    String MaryClassName = (nc1.lookup("Mary")).getClass().getName();
	    
	    System.out.println("PhilipClassName = " + PhilipClassName);
	    System.out.println("\nMaryClassName = " + MaryClassName);
	
	} catch(ArrayIndexOutOfBoundsException abe){
	    System.out.println(usageString);
	    return;
	}catch(NumberFormatException e){
	    System.out.println(usageString);
	    return;
	} catch(Exception e) {
	    System.out.println(outputHdr + "Caught unexpected Exception\n\t" 
			       + e.getMessage());
	    return;
	}

    }
}
